import React from 'react'
import createAsyncLoadingHighlighter from 'react-syntax-highlighter/dist/esm/async-syntax-highlighter'
import supportedLanguages from 'react-syntax-highlighter/dist/esm/languages/prism/supported-languages'

const theme = require('./theme.json')

const Highlighter = createAsyncLoadingHighlighter({
  loader: () => import('refractor').then(module => module.default || module),
  noAsyncLoadingLanguages: true,
  supportedLanguages
})


export const codeTagProps = {
  style: {
    fontFamily: 'Roboto Mono, Consolas, Menlo, Monaco, \"Andale Mono WT\", \"Andale Mono\", \"Lucida Console\", \"Lucida Sans Typewriter\", \"DejaVu Sans Mono\", \"Bitstream Vera Sans Mono\", \"Liberation Mono\", \"Nimbus Mono L\", \"Courier New\", Courier, monospace',
    fontSize: '14px',
    lineHeight: '1.574',
    direction: 'ltr',
    textAlign: 'left',
    whiteSpace: "pre",
    wordSpacing: 'normal',
    wordBreak: 'normal',
    MozTabSize: '2',
    OTabSize: '2',
    tabSize: '2',
    WebkitHyphens: 'none',
    MozHyphens: 'none',
    msHyphens: 'none',
    hyphens: 'none',
    background: 'none',
    color: '#24DA8D'
  }
}

export const lineNumberContainerStyle = {
  color: '#8FA6B2',
  float: 'left',
  opacity: 0.5,
  paddingRight: 20,
  textAlign: 'right'
}

function SyntaxHighligher (props) {
  return (
    <Highlighter {...props} />
  )
}

SyntaxHighligher.defaultProps = {
  style: theme,
  codeTagProps: codeTagProps,
  showLineNumbers: true,
  lineNumberContainerStyle: lineNumberContainerStyle
}

export default SyntaxHighligher


